#ifndef __creaImageIOWxDumpPanel_h_INCLUDED__
#define __creaImageIOWxDumpPanel_h_INCLUDED__

#ifdef USE_WXWIDGETS
#include <creaWx.h>
#include <creaImageIOWxGimmickView.h>

#define DUMP_SAVE_ID 1800


namespace creaImageIO
{
  /**
   * \ingroup GUI
   */
  //=====================================================================
 //=====================================================================
  /// Display all dicom tags from a given DICOM file
	class WxDumpPanel : public wxDialog
  {
  public:

    /// Constructor
	WxDumpPanel(wxWindow *parent, std::string i_filename);
    
	/// Destructor
    ~WxDumpPanel();
	
	
  private :

	 const std::string clean(const std::string &i_line);
    /// Display in a control Text all dicom tags
	void Print();

	/// wxEvent to save Dicom Tags in a text file
	 void SaveInfos(wxCommandEvent& event);

   /// Parent DialogBox
	wxDialog* dialog;

	/// Icons list
	wxImageList *mIcon;

	/// ControlText to display tags
	wxTextCtrl *DumpText;

	/// Dicom file to display
	std::string filename;

    DECLARE_EVENT_TABLE()

  }; // class WxEditFieldsPanel
  //=====================================================================

  
} // EO namespace creaImageIO


#endif // USE_WIDGETS
// EOF
#endif

